# frozen_string_literal: true

require 'oauth_im/version'
require 'oauth_im/engine'
require 'oauth_im/configuration'

module OauthIm
  DEFAULT_AUTHORIZE_URL = '/oauth2/authorize'
  DEFAULT_TOKEN_URL     = '/oauth2/token'
  DEFAULT_CALLBACK_PATH = 'callback'

  class << self
    attr_reader :configuration
  end

  def self.configure
    raise 'Already configured!' if configuration.present?

    ConfigurationProxy.new.then do |proxy|
      yield proxy
      @configuration = Configuration.new proxy
    end
  end

  def self.callback_path
    configuration&.callback_path || DEFAULT_CALLBACK_PATH
  end
end
