# frozen_string_literal: true

module OauthIm
  CONFIGURABLE_FIELDS =
    %i[api_key
       authorize_url
       callback_path
       client_id
       client_secret
       domain
       hmac
       iss_domain
       tenant_id
       token_url].freeze

  class Configuration
    attr_reader(* CONFIGURABLE_FIELDS)

    def initialize(config_proxy)
      CONFIGURABLE_FIELDS.each do |field|
        instance_variable_set "@#{field}", config_proxy.send(field)
      end
    end
  end

  class ConfigurationProxy
    attr_accessor(*CONFIGURABLE_FIELDS)
  end
end
